local StoneGateV3 = ...

-- Apply building asset processor
StoneGateV3:registerAssetProcessor("models/cubicTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/machicolations/machicolationGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/machicolations/machicolationSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/machicolations/machicolationOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/basic/basicBigSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/hoardings/hoardingBigSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/machicolations/machicolationBigSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/decorations/decoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/drawBridge.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV3:registerAssetProcessor("models/drawBridgeA.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register all stone gate set building parts and their properties
StoneGateV3:dofile("scripts/buildings.lua")
StoneGateV3:dofile("scripts/drawBridge.lua")
StoneGateV3:dofile("scripts/poleFlag.lua")

-- Register the stone gate set monument
StoneGateV3:register({
	DataType = "MONUMENT",
	Id = "STONE_GATE_V3_MONUMENT",
	Name = "STONE_GATE_V3_MONUMENT_NAME",
	Description = "STONE_GATE_V3_MONUMENT_DESC",
	BuildingType = "MONUMENT",
	BuildingPartSetList = {
		{
			Name = "STONE_GATE_V3_GATE_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V3_COREB_ROOT_PART",
		            "STONE_GATE_V3_COREB_ROOTB_PART",
	                    "STONE_GATE_V3_COREB_PORTE_PART",
		            "STONE_GATE_V3_COREB_MURET_PART",
		            "DRAW_BRIDGE_CORE_PART",
		            "DRAW_BRIDGE_A_CORE_PART",
		            "STONE_GATE_V3_COREB_ROOTC_PART",
		            "STONE_GATE_V3_COREB_COUVERT_PART",
		            "STONE_GATE_V3_COREB_TILE_COUVERT_PART"
                        }
                },
		{
			Name = "STONE_GATE_V3_OCTOGONALTOWER_PARTSETLIST_NAME",
	                BuildingPartList = {
                            "STONE_GATE_V3_COREC_ROOT_PART",
		            "STONE_GATE_V3_COREC_PORTE_PART",
		            "STONE_GATE_V3_COREC_PORTEB_PART",
		            "STONE_GATE_V3_COREC_HOARDING_PART",
		            "STONE_GATE_V3_COREC_ROOF_PART",
		            "STONE_GATE_V3_COREC_ROOTB_PART",
		            "STONE_GATE_V3_COREC_ROOFB_PART"
                        }
                },
		{
			Name = "STONE_GATE_V3_SQUAREDTOWER_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V3_CORED_ROOT_PART",
		            "STONE_GATE_V3_CORED_ROOF_PART",
		            "STONE_GATE_V3_CORED_ROOFB_PART",
		            "STONE_GATE_V3_CORED_ROOFC_PART",
		            "STONE_GATE_V3_CORED_ROOFD_PART",
		            "STONE_GATE_V3_CORED_ROOFE_PART",
		            "STONE_GATE_V3_CORED_ROOFF_PART"
                        }
                },
		{
			Name = "STONE_GATE_V3_BIGSQUAREDTOWER_PARTSETLIST_NAME",
	                BuildingPartList = {
		            "STONE_GATE_V3_COREE_ROOT_PART",
		            "STONE_GATE_V3_COREE_ROOF_PART",
		            "STONE_GATE_V3_COREE_ROOFB_PART",
		            "STONE_GATE_V3_COREE_ROOFC_PART",
		            "STONE_GATE_V3_COREE_ROOFD_PART",
		            "STONE_GATE_V3_COREE_ROOFE_PART"
                        }
                },
		{
			Name = "STONE_GATE_V3_ENTRANCE_PARTSETLIST_NAME",
	                BuildingPartList = {
 		            "STONE_GATE_V3_DOOR_PART",
  		            "STONE_GATE_V3_ADOOR_PART"
                       }
                },
		{
			Name = "STONE_GATE_V3_DECORATION_PARTSETLIST_NAME",
	                BuildingPartList = {
	                    "STONE_GATE_V3_WALL_PORTE_PART",
	                    "STONE_GATE_V3_WALL_MEDIUM_PORTE_PART",
	                    "STONE_GATE_V3_WALL_HIGH_PORTE_PART",
		            "STONE_GATE_V3_DECORATION_SFENETRE_PART",
		            "STONE_GATE_V3_DECORATION_LFENETRE_PART",
		            "STONE_GATE_V3_DECORATION_PFENETRE_PART",
		            "STONE_GATE_V3_DECORATION_ARROWSLIT_PART",
		            "STONE_GATE_V3_DECORATION_BALCONY_PART",
		            "SGV3_POLE_FLAG_RED_ROOT_PART",
		            "SGV3_POLE_FLAG_BLUE_ROOT_PART",
		            "SGV3_POLE_FLAG_GREEN_ROOT_PART",
		            "SGV3_POLE_FLAG_PURPLE_ROOT_PART",
		            "SGV3_POLE_FLAG_ORANGE_ROOT_PART",
		            "SGV3_POLE_FLAG_TURQUOISE_ROOT_PART"
                        }
                }                  
	},
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
	},
        IsEditable = true
})