
local StoneGateV3 = ...

-- Apply building asset processor
StoneGateV3:registerAssetProcessor("models/wallStairCase.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register extension A prefab nodes
StoneGateV3:registerAssetId("models/wallStairCase.fbx/Prefab/wallStairCase/StairCaseAPart", "STONE_GATE_V3_STAIRCASEA_PREFAB")

StoneGateV3:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "STONE_GATE_V3_STAIRCASEA",
	Name = "STONE_GATE_V3_STAIRCASEA_NAME",
	Description = "STONE_GATE_V3_STAIRCASEA_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "DECORATION",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "STONE_GATE_V3_STAIRCASE_PARTSETLIST_NAME",
	                BuildingPartList = { "STONE_GATE_V3_STAIRCASEA_PART" }
                }
        }
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})


StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_STAIRCASEA_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_STAIRCASEA_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "STONE_GATE_V3_STAIRCASEA_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 1 }
		}
	},
	AssetBuildingFunction = "STONE_GATE_V3_FUNCTION_STAIRCASEA"
})
StoneGateV3:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "STONE_GATE_V3_FUNCTION_STAIRCASEA";
		WorkerCapacity = 1,
                RelatedJob = { Job = "SOLDIER", Behavior = "WORK_BEHAVIOR" }
})

-- Register grounding components
StoneGateV3:registerPrefabComponent("models/wallStairCase.fbx/Prefab/wallStairCase/StairCaseAPart", {
	DataType = "COMP_GROUNDED"
})

StoneGateV3:configurePrefabFlagList("models/wallStairCase.fbx/Prefab/wallStairCase/StairCaseAPart", { "PLATFORM" })

-- Override building part components properties (generated by the building asset processor) to add building zones
StoneGateV3:registerPrefabComponent("models/wallStairCase.fbx/Prefab/wallStairCase/StairCaseAPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})
